/* ClArBase.cpp */
/*
()
() **************************************************************************
() * -inline   ClArrayBase                                    *
() **************************************************************************
()
*/

#include "ClArBase.h"

/*
()       : flush();
()    :  ;
()   : ---;
()  : ---.
()
*/
void ClArrayBase::flush()
  {
    if ( sz <= 0 ) //  
      return;
    for ( reg int i=sz-1; i>=0; i-- ) //   
      if ( el[i] != NULL )
        delete el[i];
    delete el; el = NULL;             //    
    sz = 0;                           //    
    fBI = 0;                          //    
  }

/*
()       : firstIndexOf();
()    :     ,  ,
()                  ();
()   :   ,  ;
()  :  / sz   .
()
*/
int ClArrayBase::firstIndexOf( RCClonable o, reg int i ) const
  {
    for ( ; i<sz; i++ )
      if ( el[i] == &o || el[i]!=NULL && *el[i]==o )
        break;
    return i;
  }

///*
//()       : firstBlank();
//()    :      ;
//()   : ---;
//()  :  / sz   .
//()
//*/
//int ClArrayBase::firstBlankIndex() const
//  {
//    reg int i;
//    for ( i=0; i<sz && el[i]!=NULL; i++ );
//    return i;
//  }

/*
()       : firstElementIndex();
()    :     () ;
()   : ---;
()  :  / sz   .
()
*/
int ClArrayBase::firstElementIndex() const
  {
    reg int i;
    for ( i=0; i<sz && el[i]==NULL; i++ );
    return i;
  }

/*
()       : lastElementIndex();
()    :     () ;
()   : ---;
()  :  / -1   .
()
*/
int ClArrayBase::lastElementIndex() const
  {
    reg int i;
    for ( i=sz-1; i>=0 && el[i]==NULL; i-- );
    return i;
  }

/*
()       : addElements(); //   
()    :       ;
()   :     "";
()  : ---.
()
*/
void ClArrayBase::addElements( RCClArrayBase array )
  {
    for ( reg int i=0; i<array.sz; i++ )
      add( *array.el[i] );
  }

/*
()       : isEqual();
()    :      ( );
()   :     ;
()  : true/false (/ ).
()  :   ( ,   ).
()
*/
bool ClArrayBase::isEqual( RCObject object ) const
  {
    if ( object.isA() != isA() )
      return false;
    RCClArrayBase o=RCClArrayBase(object);
    for ( reg int i=0; i<sz; i++ )
      if ( o.el[i] == NULL && el[i] != NULL ||
           o.el[i] != NULL && el[i] == NULL ||
           *o.el[i] != *el[i] )
        return false;
    return true;
  }

/*
()       : addAt();
()    :       ;
()   :   , ;
()  :    / ERROR   .
()
*/
int ClArrayBase::addAt( RCClonable o, reg int i )
  {
    if ( i < 0 )
      return ERROR; //    
    if ( i < sz )                   //     
      delete el[i];                 //    i- 
    else /* i >= sz */              // 
      CHECK( setSize(i+1), "8*O" )  //      
    el[i] = o.clone();              //     
    if ( i==fBI )
      while ( ++fBI<sz && el[fBI]!=NULL );
    return i;
  }

/*
()       : removeAt();
()    :     ;
()   : ;
()  : OK/ERROR (/).
()
*/
int ClArrayBase::removeAt( reg int i )
  {
    if ( indexOutOfRange(i) )  //    
      return ERROR;
    delete el[i]; el[i] = NULL;  //  
    if ( i<fBI )
      fBI=i;
    return OK;
  }

/*
()       : printOn();
()    :      ;
()   :  ;
()  : ---;
()  :  .
()
*/
void ClArrayBase::printOn( ostream& os ) const
  {
    os << "{\n";
    for ( int i=0; i<sz; i++ )
      if ( elPtr(i) != NULL )
        os << "  <" << *elPtr(i) << '>' << ( i<size()-1 ? ",\n" : "" );
    os << "\n}";
  }

/*
()       : setSize();
()    :     ;
()   :  ;
()  :    / ERROR   .
()
*/
int ClArrayBase::setSize( int newSize )
  {
    if ( newSize < 0 )
      return ERROR; //  

    if ( newSize != sz )  //     
      if ( newSize == 0 )  //    
        flush();  //  
      else if ( newSize == sz+1 )  //    1
        if ( !(sz%delta) )
          {
            if ( !sz )  //  
              if ( ( el = new Clonable*[delta] ) == NULL )
                return sz = ERROR; //  
              else /* el != NULL */
                for ( reg int i=0; i<int(delta); i++ )
                  el[i] = NULL;
            else /* sz > 0 */  //   
              {
                //       
                Clonable** newPtr=new Clonable*[sz+delta];
                if ( newPtr == NULL )
                  return ERROR; //  

                reg uint i=0;
                while ( i < unsigned(sz) )
                  ( newPtr[i] = el[i] ), i++;  //    
                while ( i < sz+delta )
                  ( newPtr[i] = NULL  ), i++;  //   

                delete el;    //   -  
                el = newPtr;  //   
              }
          }
        else;  //   
      else // newSize != sz+1
        {
          //       ޣ  ;
          //   ,    (ޣ,  ).
          reg const int realSize    = ( sz      + delta - 1 ) / delta * delta;
          reg const int newRealSize = ( newSize + delta - 1 ) / delta * delta;
          if ( newRealSize > realSize )  //  
            if ( sz <= 0 )  //  
              if ( ( el = new Clonable*[newRealSize] ) == NULL )
                return sz = ERROR; //  
              else /* el != NULL */
                for ( reg int i=0; i<newRealSize; i++ )
                  el[i] = NULL;
            else /* sz > 0 */  //   
              {
                //       
                Clonable** newPtr=new Clonable*[newRealSize];
                if ( newPtr == NULL )
                  return ERROR; //  

                reg int i=0;
                while ( i < sz )
                  ( newPtr[i] = el[i] ), i++;  //    
                while ( i < newRealSize )
                  ( newPtr[i] = NULL  ), i++;  //   

                delete el;    //   -  
                el = newPtr;  //   
              }
          else if ( newRealSize < realSize )  //  
            {
              for ( reg int j=newSize; j<sz; j++ )
                if ( el[j] != NULL )
                  return ERROR; //    (  -)

              //       
              Clonable** newPtr=new Clonable*[newRealSize];
              if ( newPtr == NULL )
                return ERROR; //  

              for ( reg int i=0; i<newRealSize; i++ )
                newPtr[i] = el[i];  //    

              delete el;    //   -  
              el = newPtr;  //   
            }
        }

    return sz = newSize;  //    
  }

/*
[]       :  ;
[]    :      ;
[]   : "-";
[]  :    ().
[]
*/
void ClArrayBase::operator=( RCClArrayBase A )
  {
    flush();  //   
    if ( setSize(A.sz) != ERROR )  //    
      for ( reg int i=0; i<A.sz; i++ )
        el[i] = ( (A.el[i]!=NULL) ? A.el[i]->clone() : NULL );
    else //     
      sz = ERROR; //  
    fBI=A.fBI;
  }

