/* Sortable.h */

#ifndef __Sortable_h
#define __Sortable_h

#include "Clonable.h"

_CLASSDEF(Sortable)

abstract class Sortable : public Clonable
  {

  public :

    virtual ~Sortable() {}

    virtual bool isLessThan       ( RCSortable s ) const = 0;
    virtual bool isGraiterThan    ( RCSortable s ) const
      { return ( s.isLessThan(ME) ); }
    virtual bool isNotLessThan    ( RCSortable s ) const
      { return ( !isLessThan(s) ); }
    virtual bool isNotGraiterThan ( RCSortable s ) const
      { return ( !isGraiterThan(s) ); }

    virtual bool isSortable() const { return true; }

  };

inline bool operator <  ( RCSortable s1, RCSortable s2 )
  { return s1.isLessThan(s2); }

inline bool operator >  ( RCSortable s1, RCSortable s2 )
  { return s1.isGraiterThan(s2); }

inline bool operator <= ( RCSortable s1, RCSortable s2 )
  { return s1.isNotGraiterThan(s2); }

inline bool operator >= ( RCSortable s1, RCSortable s2 )
  { return s1.isNotLessThan(s2); }

#endif  // __Sortable_h

