/* SrtArray.cpp */
/*
()
() **************************************************************************
() * -inline   ClArrayBase                                    *
() **************************************************************************
()
*/

#include "SrtArray.h"

/*
()       : flush();
()    :  ;
()   : ---;
()  : ---.
()
*/
void SrtArray::flush()
  {
    if ( sizeLocked )
      for ( reg int i=0; i<fBI; i++ )
        { delete elPtr(i); elPtr(i)=NULL; }
    else
      ClArrayBase::flush();
    fBI = 0;
  }

/*
()       : removeAt();
()    :        "" ;
()   : ;
()  : OK / ERROR (/).
()
*/
int SrtArray::removeAt( reg int i )  //  
  {
    const int _fBI=fBI;  // ClArrayBase::removeAt()  _fBI (?)
    CHECK( ClArrayBase::removeAt(i), "" );
    while ( ++i<_fBI )
      elPtr(i-1)=elPtr(i);
    elPtr(fBI=_fBI-1)=NULL;
    if ( !sizeLocked )
      setSize(fBI);
    return OK;
  }

/*
()       : indexFor();
()    :     -: min{ i>=i0: element(i)>o };
()   :    ,  ;
()  :    [0,lastIndx+1] / UNDEFINED   .
()
*/
int SrtArray::indexFor( RCSortable o, int i0 ) const
  {
    if ( i0<0 )
      i0=0;

    reg int i=i0;  //  

    //  
    if ( fBI<=0 || !(e(fBI-1)>o) )  //    - > 
      i=fBI;
    else
      if ( !(e(i)<o) )
        if ( e(i)>o )
          i = (i!=0)*UNDEFINED;
        else // !( e(i)<o || e(i)>o )
          while ( ++i<fBI-1 && !(e(i)>o) );
      else // e(b)<o && e(fBI-1)>o
        {
          reg int bot=i0;     //     
          reg int top=fBI-1;  //    

          /*        */
          // : e(bot)<o && e(top)>o && i=[(bot+top)/2]
          // : top-bot<=1 || !( e(i)<o || e(i)>o )
          // R-: (top-bot)  
          for ( i = int((bot+top)/2); top-bot>1; i = int((bot+top)/2) )
            if ( e(i)<o )       //  
              bot = i;          //        
            else if ( e(i)>o )  //  
              top = i;          //       
            else // !( e(i)<o || e(i)>o )
              break;

          /*  (-) min{ i: e(i)>o } // ( [( k + k+1 )/2] == k ) */
          while ( ++i<top && !(e(i)>o) );
        }

    return i;
  }

/*
()       : firstIndexOf();
()    :  ,   i0-, ,  ;
()   :   ,  ;
()  :  / fBI,    .
()
*/
int SrtArray::firstIndexOf( RCSortable o, reg int i0 ) const
  {
    if ( i0<0 )
      i0 = 0;

    int index=fBI;  //   (  "  ")

    if ( i0<fBI && !(e(i0)>o) )
      if ( e(i0)==o )
        index = i0;
      else
        for ( reg int i=indexFor(o,++i0)-1; i>=i0 && !(e(i)<o); i-- )
          if ( e(i)==o )
            index = i;

    return index;
  }

/*
()       : isEqual();
()    :      ( );
()   :     ;
()  : true/false (/ ).
()
*/
bool SrtArray::isEqual( RCSrtArray A ) const
  {
    if ( A.fBI != fBI )
      return false;
    for ( reg int i=0; i<fBI; i++ )
      if ( *A.elPtr(i) != *elPtr(i) )
        return false;
    return true;
  }

/*
()       : printOn();
()    :      ;
()   :  ;
()  :  .
()  : ---.
()
*/
void SrtArray::printOn( ostream& os ) const
  {
    for ( int i=0; i<fBI; i++ )
      os << *elPtr(i) << endl;
  }

/*      ClArrayBase  SrtArray */
RSrtArray SrtArray::operator=( RCClArrayBase A )
  {
    flush();
    for ( reg int i=0; i<A.size(); i++ )
      if ( A.isNotEmpty(i) )
        if ( A[i].isSortable() )
          add(RCSortable(A[i]));
    return ME;
  }

/*
()
() *** Protected   ClArrayBase ***
()
*/
/*
()       : insertAt();
()    :       ;
()   :   , ;
()  :    / ERROR   .
()
*/
int SrtArray::insertAt( RCSortable o, reg int i )
  {
    if ( i<0 || i>fBI )
      return ERROR;

    if ( !sizeLocked )
      CHECK( setSize(size()+1), " ." )  // (   ) ++
    else // sizeLocked
      if ( fBI == size() )  //    
        if ( i>=fBI )
          return UNDEFINED;  // 
        else // i<fBI
          delete elPtr(fBI--);  //   

    for ( reg int j=fBI++; j>i; j-- )  //  ""  1 
      elPtr(j)=elPtr(j-1);
    elPtr(i)=NULL;

    return addAt(o,i);  //   i-   
  }

