/* YYDefs.h */

#ifndef __YYDEFS_H
#define __YYDEFS_H

#include "Tree.h"
#include "ClArray.h"
#include "Variable.h"

#define Creal      257
#define Cint       258
#define variable   259
#define identifier 260

_CLASSDEF(TTreeVariable)
class TTreeVariable : public TVariable
  {

  public:

    TTreeVariable( const char* n, int t ) : TVariable( n, t ), value( 0 ) {}
    ~TTreeVariable() { delete value; }

    void printon( ostream& os ) { os << *value << endl; }

    PTree value;

  };

typedef union
  {
    double         Treal;
    int            Tint;
    PTTreeVariable TPTTreeVariable;
    PString        TPString;
    PTree          TPTree;
    PClArray       TPClArray;
  } YYSTYPE;

#endif // __YYDEFS_H

